]> asedeno.scripts.mit.edu Git - git.git/blobdiff - git-sh-setup.sh
git-sh-setup: Fix scripts whose PWD is a symlink to a work-dir on OS X
[git.git] / git-sh-setup.sh
index c51985e4c36022a1f58146e49cc82336c39df05a..2142308bcc6d2e2c4962859d18e12070cd4c1b1d 100755 (executable)
@@ -6,7 +6,7 @@
 # it dies.
 
 # Having this variable in your environment would break scripts because
-# you would cause "cd" to be be taken to unexpected places.  If you
+# you would cause "cd" to be taken to unexpected places.  If you
 # like CDPATH, define it for your interactive shell sessions without
 # exporting it.
 unset CDPATH
@@ -16,9 +16,42 @@ die() {
        exit 1
 }
 
-usage() {
-       die "Usage: $0 $USAGE"
-}
+if test -n "$OPTIONS_SPEC"; then
+       usage() {
+               "$0" -h
+               exit 1
+       }
+
+       parseopt_extra=
+       [ -n "$OPTIONS_KEEPDASHDASH" ] &&
+               parseopt_extra="--keep-dashdash"
+
+       eval "$(
+               echo "$OPTIONS_SPEC" |
+                       git rev-parse --parseopt $parseopt_extra -- "$@" ||
+               echo exit $?
+       )"
+else
+       dashless=$(basename "$0" | sed -e 's/-/ /')
+       usage() {
+               die "Usage: $dashless $USAGE"
+       }
+
+       if [ -z "$LONG_USAGE" ]
+       then
+               LONG_USAGE="Usage: $dashless $USAGE"
+       else
+               LONG_USAGE="Usage: $dashless $USAGE
+
+$LONG_USAGE"
+       fi
+
+       case "$1" in
+               -h|--h|--he|--hel|--help)
+               echo "$LONG_USAGE"
+               exit
+       esac
+fi
 
 set_reflog_action() {
        if [ -z "${GIT_REFLOG_ACTION:+set}" ]
@@ -29,7 +62,8 @@ set_reflog_action() {
 }
 
 git_editor() {
-       GIT_EDITOR=${GIT_EDITOR:-$(git config core.editor || echo ${VISUAL:-${EDITOR}})}
+       : "${GIT_EDITOR:=$(git config core.editor)}"
+       : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
        case "$GIT_EDITOR,$TERM" in
        ,dumb)
                echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
@@ -40,7 +74,7 @@ git_editor() {
                exit 1
                ;;
        esac
-       "${GIT_EDITOR:-vi}" "$1"
+       eval "${GIT_EDITOR:=vi}" '"$@"'
 }
 
 is_bare_repository () {
@@ -51,16 +85,34 @@ cd_to_toplevel () {
        cdup=$(git rev-parse --show-cdup)
        if test ! -z "$cdup"
        then
-               cd "$cdup" || {
-                       echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
+               case "$cdup" in
+               /*)
+                       # Not quite the same as if we did "cd -P '$cdup'" when
+                       # $cdup contains ".." after symlink path components.
+                       # Don't fix that case at least until Git switches to
+                       # "cd -P" across the board.
+                       phys="$cdup"
+                       ;;
+               ..|../*|*/..|*/../*)
+                       # Interpret $cdup relative to the physical, not logical, cwd.
+                       # Probably /bin/pwd is more portable than passing -P to cd or pwd.
+                       phys="$(unset PWD; /bin/pwd)/$cdup"
+                       ;;
+               *)
+                       # There's no "..", so no need to make things absolute.
+                       phys="$cdup"
+                       ;;
+               esac
+
+               cd "$phys" || {
+                       echo >&2 "Cannot chdir to $phys, the toplevel of the working tree"
                        exit 1
                }
        fi
 }
 
 require_work_tree () {
-       test $(git rev-parse --is-inside-work-tree) = true &&
-       test $(git rev-parse --is-inside-git-dir) = false ||
+       test $(git rev-parse --is-inside-work-tree) = true ||
        die "fatal: $0 cannot be used without a working tree."
 }
 
@@ -87,35 +139,39 @@ get_author_ident_from_commit () {
        }
        '
        encoding=$(git config i18n.commitencoding || echo UTF-8)
-       git show -s --pretty=raw --encoding="$encoding" "$1" |
+       git show -s --pretty=raw --encoding="$encoding" "$1" -- |
        LANG=C LC_ALL=C sed -ne "$pick_author_script"
 }
 
-if [ -z "$LONG_USAGE" ]
+# Make sure we are in a valid repository of a vintage we understand,
+# if we require to be in a git repository.
+if test -z "$NONGIT_OK"
 then
-       LONG_USAGE="Usage: $0 $USAGE"
-else
-       LONG_USAGE="Usage: $0 $USAGE
-
-$LONG_USAGE"
+       GIT_DIR=$(git rev-parse --git-dir) || exit
+       if [ -z "$SUBDIRECTORY_OK" ]
+       then
+               test -z "$(git rev-parse --show-cdup)" || {
+                       exit=$?
+                       echo >&2 "You need to run this command from the toplevel of the working tree."
+                       exit $exit
+               }
+       fi
+       test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
+               echo >&2 "Unable to determine absolute path of git directory"
+               exit 1
+       }
+       : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
 fi
 
-case "$1" in
-       -h|--h|--he|--hel|--help)
-       echo "$LONG_USAGE"
-       exit
-esac
-
-# Make sure we are in a valid repository of a vintage we understand.
-if [ -z "$SUBDIRECTORY_OK" ]
-then
-       : ${GIT_DIR=.git}
-       GIT_DIR=$(GIT_DIR="$GIT_DIR" git rev-parse --git-dir) || {
-               exit=$?
-               echo >&2 "You need to run this command from the toplevel of the working tree."
-               exit $exit
+# Fix some commands on Windows
+case $(uname -s) in
+*MINGW*)
+       # Windows has its own (incompatible) sort and find
+       sort () {
+               /usr/bin/sort "$@"
        }
-else
-       GIT_DIR=$(git rev-parse --git-dir) || exit
-fi
-: ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
+       find () {
+               /usr/bin/find "$@"
+       }
+       ;;
+esac